"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var fs = _interopRequireWildcard(require("fs"));

var path = _interopRequireWildcard(require("path"));

var _rawLoader = _interopRequireDefault(require("./rawLoader"));

var _schemaLoader = _interopRequireDefault(require("./schemaLoader"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const requireResolve = require('require-resolve');

class BabelInlineImportHelper {
  // ['.a', '.b', '.c', { name: '.d', loader: (content) => `~~${content}~~` }]
  static shouldBeInlined(givenPath, extensions) {
    const accept = typeof extensions === 'string' ? [extensions] : extensions || BabelInlineImportHelper.extensions;
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = accept[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        const extension = _step.value;
        const ext = extension.name || extension;

        if (givenPath.endsWith(ext)) {
          return true;
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return false;
  } // [ '', '', '' ]


  static getLoader(givenPath, extensions) {
    const curr = extensions.find(extension => {
      const ext = extension.name || extension;
      return givenPath.endsWith(ext);
    }) || {};
    return curr.loader || _rawLoader.default;
  }

  static getContents(givenPath, reference, extensions) {
    if (!reference) {
      throw new Error('"reference" argument must be specified');
    }

    const mod = requireResolve(givenPath, path.resolve(reference));

    if (!mod || !mod.src) {
      throw new Error(`Path '${givenPath}' could not be found for '${reference}'`);
    }

    const rawContent = fs.readFileSync(mod.src).toString();
    const loader = BabelInlineImportHelper.getLoader(givenPath, extensions || BabelInlineImportHelper.extensions);
    const content = loader(rawContent);
    return content;
  }

  static transformRelativeToRootPath(path, rootPathSuffix) {
    if (this.hasRoot(path)) {
      const withoutRoot = path.substring(1, path.length);
      return `${BabelInlineImportHelper.root}${rootPathSuffix || ''}/${withoutRoot}`;
    }

    if (typeof path === 'string') {
      return path;
    }

    throw new Error('ERROR: No path passed');
  }

  static hasRoot(string) {
    if (typeof string !== 'string') {
      return false;
    }

    return string.substring(0, 1) === '/';
  }

}

exports.default = BabelInlineImportHelper;

_defineProperty(BabelInlineImportHelper, "extensions", ['.raw', '.text', '.graphql', {
  name: '.schema',
  loader: _schemaLoader.default
}]);

_defineProperty(BabelInlineImportHelper, "root", global.rootPath || process.cwd());